;
;  VGA to TV converter driver
;  Copyright 1996 Tomi Engdahl
;
; Version history
; 0.1 Beta version, only mode 13H support
; 0.2 Added cirrus specific 640x480,256 mode 95H
; 0.3 Added some text mode support
; 0.4 Problems in text mode font corrected
; 0.5 Added support to nearly all VGA modes
;
INTTAB  SEGMENT 0H
INTTAB	ENDS

OldInt10h         EQU 60H
CRTC_IO_COLOR   EQU 3D4H
CRTC_IO_MONO    EQU 3B4H
SEQUENCER_IO_COLOR EQU 3C4H
SEQUENCER_IO_MONO  EQU 3C4H
MISC_OUT_IO_READ  EQU 3CCH
MISC_OUT_IO_WRITE EQU 3C2H
FEATURE_IO_COLOR  EQU 3DAH
FEATURE_IO_MONO   EQU 3BAH

COLOR_MODE      EQU 1
MONO_MODE       EQU 0


CODE	SEGMENT	PARA PUBLIC 'KOODI'
	ASSUME	CS:CODE
	ORG	100H
BEGIN:	JMP	MAIN
;
TEXT1	DB	0DH,0AH
TEXT2	DB	'ͻ',0DH,0AH
TEXT3   DB      '   VGA to TV  converter driver   ',0DH,0AH
TEXT4   DB      '   (C) 1996  Tomi Engdahl        ',0DH,0AH
TEXT5   DB      '          Version 0.6            ',0DH,0AH
TEXT6	DB	'ͼ',0DH,0AH
TEXT7	DB	'                                   ',0DH,0AH
;
INSTALLED_TEXT DB 'VGA to TV driver already installed',0DH, 0AH
;
TEMP    DW      0
DISP_TYPE DB    0
;
OrgInt10v 	dw	2 dup (?)  ; place to store old IRQ10 pointer
;
; VGA mode data format
; each data is one byte, the following data is included
; - misc output
; - feature control
; - 4 sequencer registers (1..4)
; - 25 CRTC registers (0..24)

;
;

; uncomment this if you want to have PAL modes
;INCLUDE VGAMODES.PAL

; uncomment whis if you want to have NTSC modes
INCLUDE VGAMODES.NTS

MODE_95_DATA:
; MODE = 95  COLOR
   db 39  ; misc out
   db 0  ; feature control
 ; sequencer
   db 9,15,0,14
 ; crt controller
   db 108,79,80,143,90,130,55,21,0,64,6,7,0,0,2,48,11,36,239,160,0,242,54,227,255

OrgInt10h PROC NEAR
	pushf
	call	dword ptr cs:OrgInt10v
  	ret
OrgInt10h ENDP
;
VGA_INT PROC    NEAR
        CMP     AH,00H
        JE      MODE_CHANGE
;        CMP     AH,11H
;        JE      FONT_CHANGE
	cmp	ax, 0ABCDh
	je	INSTALLED_TEST
        CALL    OrgInt10h                     ; CALL ORIGINAL ROUTINE
        IRET

;FONT_CHANGE:
;        MOV     AX,03H
;        JMP     MODE_CHANGE

INSTALLED_TEST:
        mov	ax, 0ACDCh
	mov	bx, cs
	IRET

MODE_CHANGE:
        PUSH    AX
        CALL    OrgInt10h             ; CALL ORIGINAL ROUTINE
        POP     AX

MD00:   CMP     AL,00H                    ; MODE 00H text 40x25
        JNE     MD01
        CALL    SET_FONT_8X8
        MOV     DX,OFFSET MODE_00H_DATA
        CALL    REGISTERS_SETUP
        JMP     MCEND

MD01:   CMP     AL,01H                    ; MODE 02H text 80x25
        JNE     MD02
        CALL    SET_FONT_8X8
        MOV     DX,OFFSET MODE_01H_DATA
        CALL    REGISTERS_SETUP
        JMP     MCEND

MD02:   CMP     AL,02H                    ; MODE 02H text 80x25
        JNE     MD03
        CALL    SET_FONT_8X8
        MOV     DX,OFFSET MODE_02H_DATA
        CALL    REGISTERS_SETUP
        JMP     MCEND
MD03:   CMP     AL,03H                     ; MODE 03H text 80x25 mono
        JNE     MD04
        CALL    SET_FONT_8X8
        MOV     DX,OFFSET MODE_03H_DATA
        CALL    REGISTERS_SETUP
        JMP     MCEND
; CGA graphics modes
MD04:   CMP     AL,04H                    ; mode 04H 320x200,4
        JNE     MD05
        MOV     DX,OFFSET MODE_04H_DATA
        CALL    REGISTERS_SETUP
        JMP     MCEND
MD05:   CMP     AL,05H                    ; mode 05H 320x200,4 BW
        JNE     MD06
        MOV     DX,OFFSET MODE_05H_DATA
        CALL    REGISTERS_SETUP
        JMP     MCEND
MD06:   CMP     AL,06H                    ; mode 06H 640x200,2
        JNE     MD0D
        MOV     DX,OFFSET MODE_06H_DATA
        CALL    REGISTERS_SETUP
        JMP     MCEND
; EGA graphics modes
MD0D:   CMP     AL,0DH                    ; mode 0DH  320x200,16
        JNE     MD0E
        MOV     DX,OFFSET MODE_0DH_DATA
        CALL    REGISTERS_SETUP
        JMP     MCEND
MD0E:   CMP     AL,0EH                    ; mode 0EH  640x200,16
        JNE     MD10
        MOV     DX,OFFSET MODE_0EH_DATA
        CALL    REGISTERS_SETUP
        JMP     MCEND
MD10:   CMP     AL,10H                    ; mode 10H  640x350,16
        JNE     MD11
        MOV     DX,OFFSET MODE_10H_DATA
        CALL    REGISTERS_SETUP
        JMP     MCEND
; VGA graphics modes
MD11:   CMP     AL,11H                    ; activate mode at mode 13H
        JNE     MD12
        MOV     DX,OFFSET MODE_11H_DATA
        CALL    REGISTERS_SETUP
        JMP     MCEND
MD12:   CMP     AL,12H                    ; activate mode at mode 13H
        JNE     MD13
        MOV     DX,OFFSET MODE_12H_DATA
        CALL    REGISTERS_SETUP
        JMP     MCEND
MD13:   CMP     AL,13H                    ; activate mode at mode 13H
        JNE     MD95
        MOV     DX,OFFSET MODE_13H_DATA
        CALL    REGISTERS_SETUP
        JMP     MCEND
;
; VGA card specific modes
;
; cirrus specific
MD95:   CMP     AL,95                     ; 640x480 256 color CIRRUS mode
        JNE     MCEND
        MOV     DX,OFFSET MODE_95_DATA
        CALL    REGISTERS_SETUP
        JMP     MCEND

MCEND:  IRET
VGA_INT ENDP

SET_FONT_8X8 PROC NEAR
        MOV     AX,1112H
        MOV     BL,0
        CALL    OrgInt10h                   ; 8x8 font
        PUSH    ES
        MOV     AX,0
        MOV     ES,AX
        MOV     AL,24
        MOV     BYTE PTR ES:[484H],AL       ; 25 lines
        POP     ES
        RET
SET_FONT_8X8 ENDP


; SET dx TO POINT TO DATA START
REGISTERS_SETUP PROC NEAR

        PUSH    DS
        MOV     AX,CS
        MOV     DS,AX
        MOV     SI,DX

        ; write misc output
        LODSB
        MOV     DX,MISC_OUT_IO_WRITE
        OUT DX,AL

        ; check color/mono state and set the program variable
        MOV     AL,MONO_MODE
        MOV     DISP_TYPE,AL
        MOV     DX,MISC_OUT_IO_READ
        IN      AL,DX
        AND     AL,01H
        CMP     AL,1
        JNE     NOCOLOR

        MOV     AL,COLOR_MODE
        MOV     DISP_TYPE,AL

NOCOLOR:
        ; get feature control address
        MOV     DX,FEATURE_IO_COLOR
        MOV     AL,DISP_TYPE
        CMP     AL,COLOR_MODE
        JE      COLOR1
        MOV     DX,FEATURE_IO_MONO
COLOR1:
        ; set feature control
        LODSB
        OUT     DX,AL
        NOP

        ; get sequencer address
        MOV     DX,SEQUENCER_IO_COLOR
        MOV     AL,DISP_TYPE
        CMP     AL,COLOR_MODE
        JE      COLOR2
        MOV     DX,SEQUENCER_IO_MONO
COLOR2:
        ; reset sequencer
        MOV     AL,0
        OUT     DX,AL
        NOP
        NOP
        INC     DX
        MOV     AL,0
        OUT     DX,AL
        NOP
        NOP
        DEC     DX
        ; write sequencer
        MOV     CX,4
        MOV     BL,1
SEQ_LOOP:

        MOV     AL,BL
        OUT     DX,AL
        NOP
        NOP
        INC     DX
        LODSB
        OUT     DX,AL
        NOP
        NOP
        NOP
        NOP
        DEC     DX
        INC     BL
        LOOP    SEQ_LOOP

        ; unreset sequencer
        MOV     AL,0
        OUT     DX,AL
        NOP
        NOP
        INC     DX
        MOV     AL,3
        OUT     DX,AL
        DEC     DX

        ; get CRTC address
        MOV     DX,CRTC_IO_COLOR
        MOV     AL,DISP_TYPE
        CMP     AL,COLOR_MODE
        JE      COLOR4
        MOV     DX,CRTC_IO_MONO
COLOR4:

        ; enable timing writes
        MOV     AL,11H
        OUT     DX,AL
        NOP
        INC     DX
        IN      AL,DX
        AND     AL,01111111B
        NOP
        OUT     DX,AL
        NOP
        DEC     DX

        MOV     AL,03H
        OUT     DX,AL
        INC     DX
        IN      AL,DX
        OR      AL,10000000B
        OUT     DX,AL
        DEC     DX

        ; write CRTC registers
        MOV     CX,25
        MOV     BL,0
CRTC_LOOP:
        MOV     AL,BL
        OUT     DX,AL
        NOP
        NOP
        INC DX
        LODSB
        OUT     DX,AL
        NOP
        NOP
        NOP
        NOP
        DEC     DX
        INC     BL
        LOOP    CRTC_LOOP

        ; disable timing writes
        MOV     AL,11H
        OUT     DX,AL
        NOP
        INC     DX
        IN      AL,DX
        OR      AL,10000000B
        NOP
        OUT     DX,AL
        DEC     DX

        MOV     AL,03H
        OUT     DX,AL
        NOP
        INC     DX
        IN      AL,DX
        AND     AL,01111111B
        NOP
        OUT     DX,AL
        DEC     DX


        POP     DS
        RET
REGISTERS_SETUP ENDP

; 
;       Main installing routine
;			

MAIN	PROC	NEAR
	MOV	BX,OFFSET TEXT1
	MOV	CX,224

	ASSUME	ES:INTTAB
;
;       Set the VGA BIOS interrupt number and store old value
;	for calling old interrupt routine form inside this program
;

	mov	ax, 0ABCDh   ; Check if routine already installed
	int	10h
	cmp	ax, 0ACDCh
	je	Already

	mov	ax, 3510h   ; Read video interrupt (10H) vector value
	int	21h
	mov	cs:OrgInt10v+2, es ; Store the old value for call to original routine
	mov	cs:OrgInt10v,   bx        
;;
        MOV     AX,CS           ; Set the interrupt 10H to point to my routine
	MOV	DS,AX
        MOV     DX,OFFSET VGA_INT
	MOV	AH,25H	     
        MOV     AL,10H
	INT	21H

;
;       Go to TV frequency text mode
;
        MOV     AH,00H
        MOV     AL,03H
        INT     10H

;
; Copyright texts to screen
;
        MOV     BX,OFFSET TEXT1 ; Prints the copyright text
        MOV     CX,224          ; number of characters in text
	CALL 	PRINT

;
; Return to DOS and stay in memory
;

	MOV	DX,OFFSET MAIN	; Terminate and stay resident
	INT	27H
	RET

PRINT:  MOV     AL,[BX]     ; Prints  CX character from DS:BX
	PUSH	BX
	XOR	BX,BX
	MOV	AH,0EH
	INT	10H
	POP	BX
	INC	BX
	LOOP	PRINT
	RET

Already:
        MOV     BX,OFFSET INSTALLED_TEXT ; Prints already installed text
        MOV     CX,41          ; number of characters in text
	CALL 	PRINT
	RET	
	
MAIN	ENDP
;
CODE	ENDS
	END	BEGIN

